'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var h = require('react').createElement;
var styledSystem = require('styled-system');

var _require = require('styled-system'),
    width = _require.width,
    space = _require.space,
    fontSize = _require.fontSize,
    color = _require.color;

var nano = require('nano-style');

module.exports = function (type) {
  return function () {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var name = config.name,
        _config$style = config.style,
        style = _config$style === undefined ? {} : _config$style,
        _config$system = config.system,
        system = _config$system === undefined ? [] : _config$system;


    var styleFunctions = system.map(function (key) {
      return styledSystem[key] || null;
    }).filter(function (fn) {
      return typeof fn === 'function';
    });

    var Component = nano(type).apply(undefined, [fontSize, space, width, color].concat(_toConsumableArray(styleFunctions), [style]));

    Component.propTypes = Object.assign.apply(Object, [{}, propTypes].concat(_toConsumableArray(system.map(function (key) {
      return styledSystem.propTypes[key];
    }))));

    Component.displayName = name;
    Component.defaultProps = config.props;

    return Component;
  };
};

var propTypes = Object.assign({}, styledSystem.propTypes.width, styledSystem.propTypes.fontSize, styledSystem.propTypes.space, styledSystem.propTypes.color);